/**
 * generated by Xtext 2.18.0.M3
 */
package tdt4250.ra.scoping;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import java.util.ArrayList;
import java.util.function.Consumer;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.xtext.scoping.IScope;
import org.eclipse.xtext.scoping.Scopes;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import tdt4250.ra.Course;
import tdt4250.ra.Department;
import tdt4250.ra.RaPackage;
import tdt4250.ra.ResourceAllocation;
import tdt4250.ra.Role;

/**
 * This class contains custom scoping description.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#scoping
 * on how and when to use it.
 */
@SuppressWarnings("all")
public class Rax2ScopeProvider extends AbstractRax2ScopeProvider {
  @Override
  public IScope getScope(final EObject context, final EReference ref) {
    IScope _xifexpression = null;
    if (((context instanceof ResourceAllocation) && Objects.equal(ref, RaPackage.eINSTANCE.getResourceAllocation_Role()))) {
      IScope _xblockexpression = null;
      {
        final Course course = ((ResourceAllocation) context).getCourse();
        IScope _xifexpression_1 = null;
        if ((course != null)) {
          _xifexpression_1 = Scopes.scopeFor(course.getRoles());
        } else {
          IScope _xblockexpression_1 = null;
          {
            final ArrayList<Role> allRoles = CollectionLiterals.<Role>newArrayList();
            EObject _eContainer = context.eContainer();
            final Department dep = ((Department) _eContainer);
            final Consumer<Course> _function = (Course it) -> {
              EList<Role> _roles = it.getRoles();
              Iterables.<Role>addAll(allRoles, _roles);
            };
            dep.getCourses().forEach(_function);
            _xblockexpression_1 = Scopes.scopeFor(allRoles);
          }
          _xifexpression_1 = _xblockexpression_1;
        }
        _xblockexpression = _xifexpression_1;
      }
      _xifexpression = _xblockexpression;
    } else {
      _xifexpression = super.getScope(context, ref);
    }
    return _xifexpression;
  }
}
